var WCDimensions = {
    
    Box : function(x, y, width, height) {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;  
    },
    
    FrameDimensions : function() {
        this.frame = WCNsUtils.getActiveFrame();
        this.doc = this.frame.document;
        this.viewport = new WCDimensions.BrowserViewportDimensions()
    },
    
    BrowserWindowDimensions : function() {
    },
    
    BrowserViewportDimensions : function() {
    }
}

WCDimensions.Box.prototype = {
    
    getX : function() {
        return this.x;
    },
    
    getY : function() {
        return this.y;
    },
    
    getWidth : function() {
        return this.width;
    },
    
    getHeight : function() {
        return this.height;
    }
}

WCDimensions.BrowserViewportDimensions.prototype = {
    
    getWindow : function() {
        return WCNsUtils.getCurrentBrowserWindow();
    },
    
    getBrowser : function() {
        return document.getElementById("content").selectedBrowser;
    },
    
    getScreenX : function() {
        return this.getBrowser().boxObject.screenX;
    },
    
    getScreenY : function() {
        return this.getBrowser().boxObject.screenY;
    },
    
    getScrollX : function() {
        return window.content.scrollX;
    },
    
    getScrollY : function() {
        return window.content.scrollY;
    },
    
    getHeight : function() {
        var height = 0;
        if (window.content.document.compatMode == "CSS1Compat") {
            // standards mode
            height = window.content.document.documentElement.clientHeight;
        } else { //if (compatMode == "BackCompat") 
            // quirks mode
            height = window.content.document.body.clientHeight;
        }
        return height;
    },
    
    getWidth : function() {
        if (window.content.document.compatMode == "CSS1Compat") {
            // standards mode
            return window.content.document.documentElement.clientWidth;
        } else { //if (compatMode == "BackCompat")
            // quirks mode
            return window.content.document.body.clientWidth;
        }
    }
}

WCDimensions.BrowserWindowDimensions.prototype = {
    
    getWindow : function() {
        return window;
    },
    
    getScreenX : function() {
        return window.screenX + window.screen.availLeft;
    },
    
    getScreenY : function() {
        return window.screenY + window.screen.availTop;
    },
    
    getWidth : function() {
        return window.outerWidth + window.screen.availLeft;
    },
    
    getHeight : function() {
        return window.outerHeight + window.screen.availTop;
    },
    
    getHeightIgnoringExternalities : function() {
        return window.outerHeight;
    }
}

WCDimensions.FrameDimensions.prototype = {
    
    getWindow : function() {
        return this.frame;
    },
    
    getFrameHeight : function() {
        if (this.doc.compatMode == "CSS1Compat") {
            // standards mode
            return this.doc.documentElement.clientHeight;
        } else {
            // quirks mode
            return this.doc.body.clientHeight;
        }
    },
    
    getFrameWidth : function() {
        if (this.doc.compatMode == "CSS1Compat") {
            // standards mode
            return this.doc.documentElement.clientWidth;
        } else {
            // quirks mode
            return this.doc.body.clientWidth;
        }
    },
    
    getDocumentHeight : function() {
        return this.doc.documentElement.scrollHeight;
    },
    
    getDocumentWidth : function() {
        if (this.doc.compatMode == "CSS1Compat") {
            // standards mode
            return this.doc.documentElement.scrollWidth;
        } else {
            // quirks mode
            return this.doc.body.scrollWidth;
        }
    },
    
    getScreenX : function() {
        var offsetFromOrigin = 0;
        if (this.frame.frameElement) {
            offsetFromOrigin = this.frame.frameElement.offsetLeft;
        }
        return this.viewport.getScreenX() + offsetFromOrigin;
    },
    
    getScreenY : function() {
        var offsetFromOrigin = 0;
        if (this.frame.frameElement) {
            offsetFromOrigin = this.frame.frameElement.offsetTop;
        }
        return this.viewport.getScreenY() + offsetFromOrigin;
    }
}