var WCNsUtils = {
    
    getCurrentBrowserWindow : function() {
        var currentWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
        return currentWindow.getBrowser().contentWindow;
    },

    newFileOutputStream : function(nsFile) {
        var writeFlag = 0x02; // write only
        var createFlag = 0x08; // create
        var truncateFlag = 0x20; // truncate
        
        var fileOutputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
        fileOutputStream.init(nsFile, writeFlag | createFlag | truncateFlag, 0664, null);
        return fileOutputStream;
    },

    askUserForFile : function(defaultName) {
        var result;
        var nsIFilePicker = Components.interfaces.nsIFilePicker;
        var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

        var saveas = document.getElementById("webcut-strings").getString("SaveAsMessage");
        filePicker.init(window, saveas, nsIFilePicker.modeSave);
        filePicker.appendFilters(nsIFilePicker.filterImages);
        filePicker.defaultString = defaultName;
        
        result = filePicker.show();
        if (result == nsIFilePicker.returnOK || result == nsIFilePicker.returnReplace) {
            return filePicker.file;
        }
        return null;
    },
    
    dataUrlToBinaryInputStream : function(dataUrl) {
        var nsIoService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
        var channel = nsIoService.newChannelFromURI(nsIoService.newURI(dataUrl, null, null));
        
        var binaryInputStream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
        binaryInputStream.setInputStream(channel.open());
        return binaryInputStream;
    },

    writeBinaryInputStreamToFileOutputStream : function(binaryInputStream, fileOutputStream) {
        var numBytes = binaryInputStream.available();
        var bytes = binaryInputStream.readBytes(numBytes);
        
        fileOutputStream.write(bytes, numBytes);
    }

}