WCSelection = {
    BACKGROUND_DIV : "webcutBackgroundDiv",
    DRAW_DIV : "webcutDrawDiv",
    BOX_DIV : "webcutBoxDiv",
    IDLE_IMAGE : "url('chrome://webcut/skin/idle.png') 0 no-repeat",
    SNAP_IMAGE : "url('chrome://webcut/skin/snap.png') 0 no-repeat",
    TOOL_TEXT : "Webcut/Cancel",
    oldText : null,
    drawing : false,
    cutMode : 1,
    
    toggleDraw : function(paramCutMode) {
        if (!this.check(paramCutMode)) {
            return;
        }
        this.cutMode = paramCutMode;
        if (this.drawing) {
            this.disableDrawAndGrabIfRequired();
        } else {
            this.enableDraw();
        }
    },
    
    check : function(paramCutMode) {
        if (paramCutMode == 3) {
            if (Webcut.tumblrEMail().length == 0 || Webcut.tumblrPassword().length == 0) {
                var tumblrInputError = document.getElementById("webcut-strings").getString("TumblrInputError");
                alert(tumblrInputError);
                return false;
            }
        } else if (paramCutMode == 5) {
            if (Webcut.mailAddress().length == 0) {
                var mailInputError = document.getElementById("webcut-strings").getString("MailInputError");
                alert(mailInputError);
                return false;
            }
        }
        return true;
    },
    
    insertHeaderElements : function() {
        var x = window._content;
        var pageHead = x.document.getElementsByTagName("head")[0];
    
        if (pageHead == null) {
          var pageBody = x.document.getElementsByTagName("html")[0];
          var pageHead = x.document.createElement("head");
    
          pageBody.appendChild(pageHead);
    
          var pageHead = x.document.getElementsByTagName("head")[0];
        }
    
        var cssCheck = x.document.getElementById("webcut_css");
        var jsCheck = x.document.getElementById("webcut_js");
    
        if (cssCheck == null) {
          var css = x.document.createElement("link");
          css.setAttribute("id", "webcut_css");
          css.setAttribute("rel", "stylesheet");
          css.setAttribute("type", "text/css");
          css.setAttribute("href", "chrome://webcut/skin/webcut.css");
    
          pageHead.appendChild(css);
        }
    
        if (jsCheck == null) {
          var js = x.document.createElement("script");
          js.setAttribute("id", "webcut_js");
          js.setAttribute("language", "JavaScript");
          js.setAttribute("type", "text/javascript");
          js.setAttribute("src", "chrome://webcut/content/selectionBox.js");
    
          pageHead.appendChild(js);
        }
    },
    
    enableDraw : function() {
    	var screengrabBar = window.document.getElementById("webcut_bar");
    	if (screengrabBar != null) {
    		screengrabBar.style.background = this.SNAP_IMAGE;
    		this.oldText = screengrabBar.tooltiptext;
    		screengrabBar.tooltiptext = this.TOOL_TEXT;
    	}
    
    	this.insertHeaderElements();
    	var winCon = window._content;
    
        var body = winCon.document.getElementsByTagName("html")[0];
        
        var drawDiv = winCon.document.createElement("div");
        drawDiv.setAttribute("id", this.DRAW_DIV);
        
        var backgroundDiv = winCon.document.createElement("div");
        backgroundDiv.setAttribute("id", this.BACKGROUND_DIV);
        backgroundDiv.setAttribute("class", "backgroundOverlay");
        backgroundDiv.setAttribute("onmousedown", "beginBoxDraw(event)");
        
        drawDiv.appendChild(backgroundDiv);
        body.appendChild(drawDiv);
        
        window._content.document.addEventListener("mouseup", WCSelectionOnMouseUpHandlerThatHasToExistForSomeReason, true);
        this.drawing = true;
    },
    
    disableDrawAndGrabIfRequired : function(event) {
        window._content.document.removeEventListener("mouseup", WCSelectionOnMouseUpHandlerThatHasToExistForSomeReason, true);
        var winCon = window._content;
    	var dimBox = null;
    	var box = winCon.document.getElementById(this.BOX_DIV);
    	if (box != null) {
    	    dimBox = new WCDimensions.Box(box.offsetLeft, box.offsetTop, box.clientWidth, box.clientHeight);
    	}
        var body = winCon.document.getElementsByTagName("html")[0];
        var newDiv = winCon.document.getElementById(this.DRAW_DIV);
        body.removeChild(newDiv);
    	
    	var screengrabBar = window.document.getElementById("webcut_bar");
    	if (screengrabBar != null) {
    		screengrabBar.style.background = this.IDLE_IMAGE;
    		screengrabBar.tooltiptext = this.oldText;
    	}
    	
    	this.drawing = false;
    	
    	if (box != null && event != null) {
    		Webcut.grabDocumentPortion(dimBox.getX(), dimBox.getY(), dimBox.getWidth(), dimBox.getHeight(), this.cutMode);
    	}
    }
}

function WCSelectionOnMouseUpHandlerThatHasToExistForSomeReason(event) {
    WCSelection.disableDrawAndGrabIfRequired(event);
}