var BACKGROUND_DIV = "webcutBackgroundDiv";
var DRAW_DIV = "webcutDrawDiv";
var BOX_DIV = "webcutBoxDiv";

var originX = null;
var originY = null;

function beginBoxDraw(event) {
	var winCon = window._content;
    var boxDiv = winCon.document.getElementById(BOX_DIV);
    if (boxDiv == null) {
        boxDiv = winCon.document.createElement("div");
        boxDiv.setAttribute("id", BOX_DIV);
        boxDiv.setAttribute("class", "boxOverlay");
	    winCon.document.getElementById(BACKGROUND_DIV).appendChild(boxDiv);
    }
    
    boxDiv.style.display = "none";
    boxDiv.style.left = event.clientX + "px";
    boxDiv.style.top = event.clientY + "px";
    boxDiv.setAttribute("onmousedown", "clearBox(event)");
    winCon.document.addEventListener("mousemove", boxDrawing, true);
    winCon.document.addEventListener("mouseup", endBoxDraw, true);
    originX = event.clientX;
    originY = event.clientY;
}

function boxDrawing(event) {
	var winCon = window._content;
    var boxDiv = winCon.document.getElementById(BOX_DIV);
    if (boxDiv == null) {
        return;
    }

    var mouseX = event.clientX;
    var mouseY = event.clientY;
    
    var left = mouseX < originX ? mouseX : originX;
    var top = mouseY < originY ? mouseY : originY;

    var width = Math.abs(mouseX - originX);
    var height = Math.abs(mouseY - originY);

    boxDiv.style.display = "none";
    boxDiv.style.left = left + "px";
    boxDiv.style.top = top + "px";

    boxDiv.style.width = width + "px";
    boxDiv.style.height = height + "px";
    
    boxDiv.style.display = "inline";
}

function endBoxDraw(event) {
	var winCon = window._content;
    winCon.document.removeEventListener("mousemove", boxDrawing, true);
    winCon.document.removeEventListener("mouseup", endBoxDraw, true);
}
